#include<iostream>
#include<cmath>

using namespace std;

long long n,k,a[2001][2001],minni,minnj,maxxi,maxxj,br=0,brm=0,m=1,p1,p2,pov;

int main()
{
    cin>>n>>k;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            cin>>a[i][j];
        }
    }
    tamo:
        brm=0;
        pov=0;
            minni=n+2;
            maxxi=0;
            minnj=n+2;
            maxxj=0;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            if(a[i][j]==m) {brm++;
            if(i<=minni) minni=i;
            if(j<=minnj) minnj=j;
            if(i>=maxxi) maxxi=i;
            if(j>=maxxj) maxxj=j;}
        }
    }
    p1=abs(minni-maxxi)+1;
    p2=abs(minnj-maxxj)+1;
    pov=p1*p2;
    if(brm==pov and brm!=0) br++;
    if(m<k) {m++; goto tamo;}
    else cout<<br;


    return 0;
}